package org.openxma.dsl.reference.dtoassembler.validation;

import org.springframework.validation.Errors;
import org.openxma.dsl.reference.base.validation.BaseEntityValidator;
import org.openxma.dsl.reference.dtoassembler.model.Child;
import org.springframework.validation.ValidationUtils;

public abstract class ChildGenValidator extends BaseEntityValidator {
    
    public boolean isParentRequired(Child child) {
        return Boolean.TRUE;
    }
        
    @SuppressWarnings("unchecked")
    public boolean supports(Class clazz) {
        return Child.class.isAssignableFrom(clazz);
    }
    
    public Errors validate(Child child) {
        Errors errors = createErrors(child);      
        super.validate(child,errors);
        validate(child,errors);
        return errors;
    }

    public void validate(Object object, Errors errors) {
        Child child = (Child) object;
        if (isParentRequired(child)) {
            ValidationUtils.rejectIfEmpty(errors, "parent", "field.required");
        }
    }
    
}
