package org.openxma.dsl.reference.jdbc.support;

import java.sql.SQLException;

import org.openxma.dsl.reference.dao.UniqueKeyConstraintViolationException;
import org.springframework.dao.DataAccessException;
import org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator;

public class HsqlExceptionTranslator extends SQLErrorCodeSQLExceptionTranslator {

	@Override
	protected DataAccessException customTranslate(String task, String sql, SQLException sqlEx) {
		if ("23000".equals(sqlEx.getSQLState())) {
			throw new UniqueKeyConstraintViolationException(sqlEx.getMessage(), sqlEx);
		}
		return super.customTranslate(task, sql, sqlEx);
	}

}
