package org.openxma.dsl.reference.ui.layouting.client;

import java.util.Locale;
import java.util.ResourceBundle;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import at.spardat.xma.page.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.simple.*;
import at.spardat.enterprise.fmt.*;

/**
 * This class implements the generic client part of FieldParts.
 * It implements the widgets and models of the page.
 *
 */
public abstract class FieldPartsGen extends org.openxma.dsl.platform.xma.client.DslNotebookPage {
    Composite fieldParts_composite_0_0W;
    Composite fieldParts_composite_0_0_set0W;
    Label fieldParts_composite_0_0_set0_centered;
    Label customer1_lastNameL;
    Text customer1_lastNameW;
    ISimpleWMClient customer1_lastName;
    Composite fieldParts_composite_0_0_set1W;
    Label fieldParts_composite_0_0_set1_centered;
    Label customer2_lastNameL;
    Text customer2_lastNameW;
    ISimpleWMClient customer2_lastName;
    WModel[] widgetModels;
    Control[] widgets;

    /**
     * Constructs the FieldPartsGen.
     * @param notebook the Notebook this page belongs to.
     */
    public FieldPartsGen(Notebook notebook) {
        super(notebook,false);
        createModels();
    }

    /**
     * Create and initialize the WidgetModels of the page.
     * Subpages which are not lazy are created too.
     */
    public void createModels() {
        Locale locale = getComponent().getContext().getLocale();
        IFmt formatter;
        CompoundValidator compound;
        customer1_lastName = new SimpleWMClient((short) 0, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(50);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(50);
        compound.setFormatter(formatter);
        formatter = compound;
        customer1_lastName.setFmt(formatter);
        customer2_lastName = new SimpleWMClient((short) 1, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(50);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(50);
        compound.setFormatter(formatter);
        formatter = compound;
        customer2_lastName.setFmt(formatter);

        widgetModels = new WModel[] { (WModel) customer1_lastName, (WModel) customer2_lastName };
        getComponent().registerPageModel(this);
    }

    /**
     * Indicate if the WidgetModels are already created.
     * @return true if the WidgetModels exist.
     */
    public boolean hasModels() {
        return widgetModels != null;
    }

    /**
     * Remove all WidgetModels of the page.
     */
    public void removeWidgetModels() {
        customer1_lastName = null;
        customer2_lastName = null;
        widgetModels = null;
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return Layouting.FieldPartsClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public Layouting getTypedComponent() {
        return (Layouting) getComponent();
    }

    /**
     * Returns an array of all Widgets of this page.
     * @return array of Widgets. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public Control[] getWidgets() {
        return widgets;
    }

    /**
     * Replaces the widget array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWidgets(Control[] widgets) {
        this.widgets=widgets;
    }

    /**
     * Create and initialize all SWT-Widgets of the page.
     * It <br>
     * <ul>
     * <li> instantiates the Widgets </li>
     * <li> sets constant texts (Title, Labels, Tooltips) and Images </li>
     * <li> registers the eventadapter </li>
     * <li> defines the Layout (Attachments, Distances, Sizes) </li>
     * <li> sets the focus </li>
     * <li> defines the Taborder </li>
     * </ul>
     */
    protected void createWidgets() {
        FormData data;
        Control[] tabOrder;
        EventAdapter adapter = new EventAdapter(this);
        Locale locale = getComponent().getContext().getLocale();
        ResourceBundle messages = ResourceBundle.getBundle("org.openxma.dsl.reference.ui.layouting.client.Layouting",locale);
        final Scaler scaler = Scaler.getInstance(getComposite());
        Control lastControl;

        Composite pageCompositefieldPartsW = getComposite();
        FormLayout layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        pageCompositefieldPartsW.setLayout(layout);

        fieldParts_composite_0_0W = new Composite(pageCompositefieldPartsW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        fieldParts_composite_0_0W.setLayout(layout);
        fieldParts_composite_0_0W.setData("WIDGET_ID","fieldParts_composite_0_0W");

        fieldParts_composite_0_0_set0W = new Composite(fieldParts_composite_0_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        fieldParts_composite_0_0_set0W.setLayout(layout);
        fieldParts_composite_0_0_set0W.setData("WIDGET_ID","fieldParts_composite_0_0_set0W");

        fieldParts_composite_0_0_set0_centered = new Label (fieldParts_composite_0_0_set0W,SWT.LEFT);
        fieldParts_composite_0_0_set0_centered.setVisible(false);
        fieldParts_composite_0_0_set0_centered.setData("WIDGET_ID","fieldParts_composite_0_0_set0_centered");

        customer1_lastNameL = new Label (fieldParts_composite_0_0_set0W,SWT.LEFT|SWT.WRAP);
        customer1_lastNameL.setText(messages.getString("FieldParts.customer1_lastNameL"));
        customer1_lastNameL.setData("WIDGET_ID","customer1_lastNameL");

        customer1_lastNameW = new Text(fieldParts_composite_0_0_set0W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        customer1_lastNameW.setToolTipText(messages.getString("FieldParts.customer1_lastNameWTip"));
        customer1_lastNameW.setData("WIDGET_ID","customer1_lastNameW");
        customer1_lastNameW.addFocusListener(adapter);
        customer1_lastNameW.addModifyListener(adapter);
        customer1_lastNameW.addVerifyListener(adapter);

        fieldParts_composite_0_0_set1W = new Composite(fieldParts_composite_0_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        fieldParts_composite_0_0_set1W.setLayout(layout);
        fieldParts_composite_0_0_set1W.setData("WIDGET_ID","fieldParts_composite_0_0_set1W");

        fieldParts_composite_0_0_set1_centered = new Label (fieldParts_composite_0_0_set1W,SWT.LEFT);
        fieldParts_composite_0_0_set1_centered.setVisible(false);
        fieldParts_composite_0_0_set1_centered.setData("WIDGET_ID","fieldParts_composite_0_0_set1_centered");

        customer2_lastNameL = new Label (fieldParts_composite_0_0_set1W,SWT.LEFT|SWT.WRAP);
        customer2_lastNameL.setText(messages.getString("FieldParts.customer2_lastNameL"));
        customer2_lastNameL.setData("WIDGET_ID","customer2_lastNameL");

        customer2_lastNameW = new Text(fieldParts_composite_0_0_set1W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        customer2_lastNameW.setToolTipText(messages.getString("FieldParts.customer2_lastNameWTip"));
        customer2_lastNameW.setData("WIDGET_ID","customer2_lastNameW");
        customer2_lastNameW.addFocusListener(adapter);
        customer2_lastNameW.addModifyListener(adapter);
        customer2_lastNameW.addVerifyListener(adapter);

        widgets = new Control[] { fieldParts_composite_0_0W, fieldParts_composite_0_0_set0W, fieldParts_composite_0_0_set0_centered, customer1_lastNameL, customer1_lastNameW, fieldParts_composite_0_0_set1W, fieldParts_composite_0_0_set1_centered, customer2_lastNameL, customer2_lastNameW };

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        fieldParts_composite_0_0W.setLayoutData(data);

        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        fieldParts_composite_0_0_set0W.setLayoutData(data);
        lastControl=fieldParts_composite_0_0_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        fieldParts_composite_0_0_set1W.setLayoutData(data);
        lastControl=fieldParts_composite_0_0_set1W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        fieldParts_composite_0_0_set0_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(fieldParts_composite_0_0_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer1_lastNameL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(350);
        data.left = new FormAttachment(customer1_lastNameL,scaler.convertXToCurrent(14),SWT.RIGHT);
        data.top = new FormAttachment(fieldParts_composite_0_0_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer1_lastNameW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        fieldParts_composite_0_0_set1_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(fieldParts_composite_0_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer2_lastNameL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(350);
        data.left = new FormAttachment(customer2_lastNameL,scaler.convertXToCurrent(14),SWT.RIGHT);
        data.top = new FormAttachment(fieldParts_composite_0_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer2_lastNameW.setLayoutData(data);


        tabOrder = new Control[1];
        tabOrder[0] = fieldParts_composite_0_0W;
        pageCompositefieldPartsW.setTabList(tabOrder);
        tabOrder = new Control[2];
        tabOrder[0] = fieldParts_composite_0_0_set0W;
        tabOrder[1] = fieldParts_composite_0_0_set1W;
        fieldParts_composite_0_0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = customer1_lastNameW;
        fieldParts_composite_0_0_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = customer2_lastNameW;
        fieldParts_composite_0_0_set1W.setTabList(tabOrder);
    }

    /**
     * Remove all Widgets of the page after they have been disposed.
     */
    public void removeWidgets() {
        fieldParts_composite_0_0W = null;
        fieldParts_composite_0_0_set0W = null;
        fieldParts_composite_0_0_set0_centered = null;
        customer1_lastNameL = null;
        customer1_lastNameW = null;
        fieldParts_composite_0_0_set1W = null;
        fieldParts_composite_0_0_set1_centered = null;
        customer2_lastNameL = null;
        customer2_lastNameW = null;
        widgets = null;
    }


    /**
     * Attaches all WidgetModels of the page to there corresponding Widgets.
     */
    public void attachUIImpl() throws AttachmentExceptionClient {
        customer1_lastNameW.setData(customer1_lastName.getUIDelegate());
        customer1_lastName.getUIDelegate().attachUI(customer1_lastNameW,customer1_lastNameL);
        customer2_lastNameW.setData(customer2_lastName.getUIDelegate());
        customer2_lastName.getUIDelegate().attachUI(customer2_lastNameW,customer2_lastNameL);
    }

    /**
     * Enables or disables Widgets according to the current state of the page.
     * This method is called every time the content of any WizardModel of the
     * Page may have been changed. <br>
     * This method is called immediately after {@link #determineState()}.
     */
    public void stateChanged() {

        customer1_lastName.setMandatory(true);
        customer2_lastName.setMandatory(true);
    }

    /**
     * This method will be called every time the FieldParts becomes visible.
     */
    protected void enter() {
        super.enter();
    }

    /**
     * Calls the clientevent configured for the widget of the event.
     *
     * @param event the SWT-Event that happened.
     * @param type the type of the Event, as defined by the event type constants in class SWT.
     */
    protected void clientEvent(SelectionEvent event,int type) {
    }

    /**
     * Creates the coresponding TabItem
     */
    protected TabItem createTabItem(TabFolder LayoutingPage_tabfolder_0_0_0_0W,int index) {
        Locale locale = getComponent().getContext().getLocale();
        ResourceBundle messages = ResourceBundle.getBundle("org.openxma.dsl.reference.ui.layouting.client.Layouting",locale);

        TabItem fieldPartsW = new TabItem (LayoutingPage_tabfolder_0_0_0_0W, SWT.NULL, index);
        fieldPartsW.setText(messages.getString("FieldParts"));
        fieldPartsW.setControl(getComposite());
        fieldPartsW.setData(this);

        return fieldPartsW;
    }
}
