package org.openxma.dsl.reference.ui.styleselectors.client;

import java.util.Locale;
import java.util.ResourceBundle;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import at.spardat.xma.component.*;
import at.spardat.xma.page.*;
import at.spardat.xma.mdl.*;
import at.spardat.xma.mdl.table.*;
import at.spardat.enterprise.fmt.*;

/**
 * This class implements the generic client part of TableColumnStylePage.
 * It implements the widgets and models of the page.
 *
 */
public abstract class TableColumnStylePageGen extends org.openxma.dsl.platform.xma.client.DslDialogPage {
    Table customerTableW;
    at.spardat.xma.mdl.table.TableLayoutManager customerTableWLM;
    ITableWMClient customerTable;
    static final int CUSTOMERTABLE_FIRSTNAME = 0;
    static final int CUSTOMERTABLE_LASTNAME = 1;
    WModel[] widgetModels;
    Control[] widgets;

    /**
     * Constructs the TableColumnStylePageGen.
     * @param parent the parent page
     */
    public TableColumnStylePageGen(PageClient parent) {
        super(parent,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the TableColumnStylePageGen.
     * @param component the component this page belongs to
     */
    public TableColumnStylePageGen(ComponentClient component) {
        super(component,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the TableColumnStylePageGen.
     * @param component the component this page belongs to
     * @param parentShell the shell of the calling dialog
     */
    public TableColumnStylePageGen(ComponentClient component, Shell parentShell) {
        super(component,parentShell,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the TableColumnStylePageGen.
     * @param component the component this page belongs to
     * @param parentShell the shell of the calling dialog
     * @param modal the SWT-style for the desired modality
     */
    public TableColumnStylePageGen(ComponentClient component, Shell parentShell, int modal) {
        super(component,parentShell,false,modal|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }


    /**
     * Gives the URI of the help for this page
     * This URI is relative to the download-URI of the component
     * @return the relative URI of the help for this page
     */
    public String getHelpUri() {
        return "help/org/openxma/dsl/reference/ui/styleselectors/TableColumnStylePage.html";
    }

    /**
     * Create and initialize the WidgetModels of the page.
     * Subpages which are not lazy are created too.
     */
    public void createModels() {
        Locale locale = getComponent().getContext().getLocale();
        IFmt formatter;
        customerTable = new TableWMClient((short) 0,this,2,TableWMClient.S_NULL|TableWM.S_ONE_WAY);
        formatter = AStringFmt.getInstance(25);
        ((TableWMClient)customerTable).getColumn(CUSTOMERTABLE_FIRSTNAME).setFormatter(formatter);
        formatter = AStringFmt.getInstance(50);
        ((TableWMClient)customerTable).getColumn(CUSTOMERTABLE_LASTNAME).setFormatter(formatter);

        widgetModels = new WModel[] { (WModel) customerTable };
        getComponent().registerPageModel(this);
    }

    /**
     * Indicate if the WidgetModels are already created.
     * @return true if the WidgetModels exist.
     */
    public boolean hasModels() {
        return widgetModels != null;
    }

    /**
     * Remove all WidgetModels of the page.
     */
    public void removeWidgetModels() {
        customerTable = null;
        widgetModels = null;
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return StyleSelectors.TableColumnStylePageClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public StyleSelectors getTypedComponent() {
        return (StyleSelectors) getComponent();
    }

    /**
     * Returns an array of all Widgets of this page.
     * @return array of Widgets. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public Control[] getWidgets() {
        return widgets;
    }

    /**
     * Replaces the widget array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWidgets(Control[] widgets) {
        this.widgets=widgets;
    }

    /**
     * Create and initialize all SWT-Widgets of the page.
     * It <br>
     * <ul>
     * <li> instantiates the Widgets </li>
     * <li> sets constant texts (Title, Labels, Tooltips) and Images </li>
     * <li> registers the eventadapter </li>
     * <li> defines the Layout (Attachments, Distances, Sizes) </li>
     * <li> sets the focus </li>
     * <li> defines the Taborder </li>
     * </ul>
     */
    protected void createWidgets() {
        FormData data;
        Control[] tabOrder;
        EventAdapter adapter = new EventAdapter(this);
        Locale locale = getComponent().getContext().getLocale();
        ResourceBundle messages = ResourceBundle.getBundle("org.openxma.dsl.reference.ui.styleselectors.client.StyleSelectors",locale);
        final Scaler scaler = Scaler.getInstance(getComposite());

        final Shell shell = getShell();
        if(getDialog()==this) {
            shell.setText(messages.getString("TableColumnStylePage"));
            shell.addHelpListener(adapter);
        } else {
            getComposite().addHelpListener(adapter);
        }
        Composite TableColumnStylePageCompW = getComposite();
        FormLayout layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        TableColumnStylePageCompW.setLayout(layout);

        customerTableW = new Table(TableColumnStylePageCompW, SWT.SINGLE|SWT.BORDER|SWT.FULL_SELECTION);
        customerTableW.setHeaderVisible(true);
        customerTableW.setLinesVisible(true);
        customerTableW.setData("WIDGET_ID","customerTableW");
        customerTableW.addSelectionListener(adapter);
        TableColumn customerTable_firstName = new TableColumn(customerTableW,SWT.LEFT);
        customerTable_firstName.setText(messages.getString("TableColumnStylePage.customerTable_firstName"));
        customerTable_firstName.addSelectionListener(adapter);
        TableColumn customerTable_lastName = new TableColumn(customerTableW,SWT.LEFT);
        customerTable_lastName.setText(messages.getString("TableColumnStylePage.customerTable_lastName"));
        customerTable_lastName.addSelectionListener(adapter);
        customerTableWLM = new at.spardat.xma.mdl.table.TableLayoutManager();
        customerTableWLM.manageTable(customerTableW,at.spardat.xma.mdl.table.TableLayoutManager.NONE);
        customerTableWLM.setMinLimit(scaler.convertXToCurrent(10));

        widgets = new Control[] { customerTableW };

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        customerTableW.setLayoutData(data);


        if(getDialog()==this) {
            shell.setTabList(new Control[] { TableColumnStylePageCompW });
        }
        tabOrder = new Control[1];
        tabOrder[0] = customerTableW;
        TableColumnStylePageCompW.setTabList(tabOrder);
        if(getDialog()==this) {
            shell.setSize(scaler.convertXToCurrent(640), scaler.convertYToCurrent(480));
        }
    }

    /**
     * Remove all Widgets of the page after they have been disposed.
     */
    public void removeWidgets() {
        customerTableW = null;
        widgets = null;
    }


    /**
     * Attaches all WidgetModels of the page to there corresponding Widgets.
     */
    public void attachUIImpl() throws AttachmentExceptionClient {
        TableColumn[] cols;
        customerTableW.setData(customerTable.getUIDelegate());
        customerTable.getUIDelegate().attachUI(customerTableW,null);
        cols = customerTableW.getColumns();
        for(int i = 0; i<cols.length; i++) {
            cols[i].setData(customerTable.getUIDelegate());
        }

    }

    /**
     * This method will be called every time the TableColumnStylePage becomes visible.
     */
    protected void enter() {
        super.enter();
    }

    /**
     * Calls the clientevent configured for the widget of the event.
     *
     * @param event the SWT-Event that happened.
     * @param type the type of the Event, as defined by the event type constants in class SWT.
     */
    protected void clientEvent(SelectionEvent event,int type) {
    }

}
