package org.openxma.dsl.reference.ui.styleselectors.server;

import at.spardat.xma.component.ComponentServer;
import at.spardat.xma.session.XMASessionServer;

/**
 * This class implements the generic server part of StyleSelectors.
 * It provides the mapping between typeIds and classnames
 * of all pages in the component.
 *
 */
abstract public class StyleSelectorsGen extends org.openxma.dsl.platform.xma.SpringComponentServer {

    org.openxma.dsl.reference.dto.CustomerView customer1;
    org.openxma.dsl.reference.dto.CustomerView customer2;
    java.util.Collection customers;

    /**
     * Initializes the StyleSelectorsGen. This method is called
     * by the XMA-Runtime.
     *
     * @param session the XMASession, this StyleSelectorsGen belongs to.
     * @param id the unique id of this StyleSelectors.
     */
    public StyleSelectorsGen (XMASessionServer session,short id) {
        super (session,false,id);
    }


    /** the unique typeId for the page TableColumnStylePage */
    public static final short TableColumnStylePageClass = 0;
    /** the unique typeId for the page StyleSelectorsPage */
    public static final short StyleSelectorsPageClass = 1;

    /**
    * Array of the classnames of all pages in
    * this component. The typeIds are used as indices
    * into this array.
     */
    static final String[] modelClasses = {
        "TableColumnStylePage",
        "StyleSelectorsPage"
    };

    /**
    * Gets the short classname for the given typeId of
    * a page in this component. The short classname does
    * not contain the package.
    *
    * @param typeId the unique typeId
    * @return the short classname
     */
    static public String getShortModelClass(short typeId) {
        return modelClasses[typeId];
    }

    /**
    * Gets the full classname for the given typeId of
    * a page in this component.
    *
    * @param typeId the unique typeId
    * @return the full classname
     */
    public String getModelClass(short typeId) {
        return "org.openxma.dsl.reference.ui.styleselectors.server."+modelClasses[typeId];
    }

    /**
     * returns the customer1
     */
    public org.openxma.dsl.reference.dto.CustomerView getCustomer1() {
        return customer1;
    }

    /**
     * sets the customer1
     */
    public void setCustomer1(org.openxma.dsl.reference.dto.CustomerView customer1) {
        this.customer1 = customer1;
    }

    /**
     * returns the customer2
     */
    public org.openxma.dsl.reference.dto.CustomerView getCustomer2() {
        return customer2;
    }

    /**
     * sets the customer2
     */
    public void setCustomer2(org.openxma.dsl.reference.dto.CustomerView customer2) {
        this.customer2 = customer2;
    }

    /**
     * returns the customers
     */
    public java.util.Collection getCustomers() {
        return customers;
    }

    /**
     * sets the customers
     */
    public void setCustomers(java.util.Collection customers) {
        this.customers = customers;
    }


}
