package org.openxma.dsl.reference.validation;

import org.springframework.validation.Errors;
import org.openxma.dsl.reference.base.validation.BaseEntityValidator;
import org.openxma.dsl.reference.model.Address;

public abstract class AddressGenValidator extends BaseEntityValidator {
        
    @SuppressWarnings("unchecked")
    public boolean supports(Class clazz) {
        return Address.class.isAssignableFrom(clazz);
    }
    
    public Errors validate(Address address) {
        Errors errors = createErrors(address);      
        super.validate(address,errors);
        validate(address,errors);
        return errors;
    }

    public void validate(Object object, Errors errors) {
        Address address = (Address) object;
        rejectIfMaxLength(errors,"streetName",address.getStreetName(),30);
        rejectIfMaxLength(errors,"zip",address.getZip(),10);
        rejectIfMaxLength(errors,"city",address.getCity(),30);
        rejectIfMaxLength(errors,"country",address.getCountry(),25);
    }
    
}
