package org.openxma.dsl.reference.validation;

import org.springframework.validation.Errors;
import org.openxma.dsl.platform.validation.Validators;
import org.openxma.dsl.reference.model.Category;
import org.springframework.validation.ValidationUtils;

public abstract class CategoryGenValidator extends Validators {
    
    public boolean isNameRequired(Category category) {
        return Boolean.TRUE;
    }
        
    @SuppressWarnings("unchecked")
    public boolean supports(Class clazz) {
        return Category.class.isAssignableFrom(clazz);
    }
    
    public Errors validate(Category category) {
        Errors errors = createErrors(category);      
        validate(category,errors);
        return errors;
    }

    public void validate(Object object, Errors errors) {
        Category category = (Category) object;
        if (isNameRequired(category)) {
            ValidationUtils.rejectIfEmptyOrWhitespace(errors, "name", "field.required");
        }
    }
    
}
