package org.openxma.dsl.reference.validation;

import org.springframework.validation.Errors;
import org.openxma.dsl.reference.model.SingleRole;
import org.openxma.dsl.reference.validation.RoleValidator;

public abstract class SingleRoleGenValidator extends RoleValidator {
        
    @SuppressWarnings("unchecked")
    public boolean supports(Class clazz) {
        return SingleRole.class.isAssignableFrom(clazz);
    }
    
    public Errors validate(SingleRole singleRole) {
        Errors errors = createErrors(singleRole);      
        super.validate(singleRole,errors);
        validate(singleRole,errors);
        return errors;
    }

    public void validate(Object object, Errors errors) {
        SingleRole singleRole = (SingleRole) object;
    }
    
}
